/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.message;

import org.apache.dubbo.common.stream.StreamObserver;
import org.apache.dubbo.common.URL;
import org.apache.dubbo.rpc.Invoker;
import org.apache.dubbo.rpc.PathResolver;
import org.apache.dubbo.rpc.RpcException;
import org.apache.dubbo.rpc.ServerService;
import org.apache.dubbo.rpc.TriRpcStatus;
import org.apache.dubbo.rpc.model.MethodDescriptor;
import org.apache.dubbo.rpc.model.ServiceDescriptor;
import org.apache.dubbo.rpc.model.StubMethodDescriptor;
import org.apache.dubbo.rpc.model.StubServiceDescriptor;
import org.apache.dubbo.rpc.stub.BiStreamMethodHandler;
import org.apache.dubbo.rpc.stub.ServerStreamMethodHandler;
import org.apache.dubbo.rpc.stub.StubInvocationUtil;
import org.apache.dubbo.rpc.stub.StubInvoker;
import org.apache.dubbo.rpc.stub.StubMethodHandler;
import org.apache.dubbo.rpc.stub.StubSuppliers;
import org.apache.dubbo.rpc.stub.UnaryStubMethodHandler;

import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public final class DubboSmsMessageServiceTriple {

    public static final String SERVICE_NAME = SmsMessageService.SERVICE_NAME;

    private static final StubServiceDescriptor serviceDescriptor = new StubServiceDescriptor(SERVICE_NAME,SmsMessageService.class);

    static {
        org.apache.dubbo.rpc.protocol.tri.service.SchemaDescriptorRegistry.addSchemaDescriptor(SERVICE_NAME,MessageProto.getDescriptor());
        StubSuppliers.addSupplier(SERVICE_NAME, DubboSmsMessageServiceTriple::newStub);
        StubSuppliers.addSupplier(SmsMessageService.JAVA_SERVICE_NAME,  DubboSmsMessageServiceTriple::newStub);
        StubSuppliers.addDescriptor(SERVICE_NAME, serviceDescriptor);
        StubSuppliers.addDescriptor(SmsMessageService.JAVA_SERVICE_NAME, serviceDescriptor);
    }

    @SuppressWarnings("all")
    public static SmsMessageService newStub(Invoker<?> invoker) {
        return new SmsMessageServiceStub((Invoker<SmsMessageService>)invoker);
    }

    /**
         * <pre>
         *  调用终端
         * </pre>
         */
    private static final StubMethodDescriptor sendSmsMethod = new StubMethodDescriptor("sendSms",
    com.ywt.gapi.message.SendSmsRequest.class, com.ywt.gapi.message.SendSmsResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.message.SendSmsRequest::parseFrom,
    com.ywt.gapi.message.SendSmsResponse::parseFrom);

    private static final StubMethodDescriptor sendSmsAsyncMethod = new StubMethodDescriptor("sendSms",
    com.ywt.gapi.message.SendSmsRequest.class, java.util.concurrent.CompletableFuture.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.message.SendSmsRequest::parseFrom,
    com.ywt.gapi.message.SendSmsResponse::parseFrom);

    private static final StubMethodDescriptor sendSmsProxyAsyncMethod = new StubMethodDescriptor("sendSmsAsync",
    com.ywt.gapi.message.SendSmsRequest.class, com.ywt.gapi.message.SendSmsResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.message.SendSmsRequest::parseFrom,
    com.ywt.gapi.message.SendSmsResponse::parseFrom);





    public static class SmsMessageServiceStub implements SmsMessageService{
        private final Invoker<SmsMessageService> invoker;

        public SmsMessageServiceStub(Invoker<SmsMessageService> invoker) {
            this.invoker = invoker;
        }

            /**
         * <pre>
         *  调用终端
         * </pre>
         */
        @Override
        public com.ywt.gapi.message.SendSmsResponse sendSms(com.ywt.gapi.message.SendSmsRequest request){
            return StubInvocationUtil.unaryCall(invoker, sendSmsMethod, request);
        }

        public CompletableFuture<com.ywt.gapi.message.SendSmsResponse> sendSmsAsync(com.ywt.gapi.message.SendSmsRequest request){
            return StubInvocationUtil.unaryCall(invoker, sendSmsAsyncMethod, request);
        }

            /**
         * <pre>
         *  调用终端
         * </pre>
         */
        @Override
        public void sendSms(com.ywt.gapi.message.SendSmsRequest request, StreamObserver<com.ywt.gapi.message.SendSmsResponse> responseObserver){
            StubInvocationUtil.unaryCall(invoker, sendSmsMethod , request, responseObserver);
        }



    }

    public static abstract class SmsMessageServiceImplBase implements SmsMessageService, ServerService<SmsMessageService> {

        private <T, R> BiConsumer<T, StreamObserver<R>> syncToAsync(java.util.function.Function<T, R> syncFun) {
            return new BiConsumer<T, StreamObserver<R>>() {
                @Override
                public void accept(T t, StreamObserver<R> observer) {
                    try {
                        R ret = syncFun.apply(t);
                        observer.onNext(ret);
                        observer.onCompleted();
                    } catch (Throwable e) {
                        observer.onError(e);
                    }
                }
            };
        }

        @Override
        public final Invoker<SmsMessageService> getInvoker(URL url) {
            PathResolver pathResolver = url.getOrDefaultFrameworkModel()
            .getExtensionLoader(PathResolver.class)
            .getDefaultExtension();
            Map<String,StubMethodHandler<?, ?>> handlers = new HashMap<>();

            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/sendSms" );
            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/sendSmsAsync" );

            BiConsumer<com.ywt.gapi.message.SendSmsRequest, StreamObserver<com.ywt.gapi.message.SendSmsResponse>> sendSmsFunc = this::sendSms;
            handlers.put(sendSmsMethod.getMethodName(), new UnaryStubMethodHandler<>(sendSmsFunc));
            BiConsumer<com.ywt.gapi.message.SendSmsRequest, StreamObserver<com.ywt.gapi.message.SendSmsResponse>> sendSmsAsyncFunc = syncToAsync(this::sendSms);
            handlers.put(sendSmsProxyAsyncMethod.getMethodName(), new UnaryStubMethodHandler<>(sendSmsAsyncFunc));




            return new StubInvoker<>(this, url, SmsMessageService.class, handlers);
        }


        @Override
        public com.ywt.gapi.message.SendSmsResponse sendSms(com.ywt.gapi.message.SendSmsRequest request){
            throw unimplementedMethodException(sendSmsMethod);
        }





        @Override
        public final ServiceDescriptor getServiceDescriptor() {
            return serviceDescriptor;
        }
        private RpcException unimplementedMethodException(StubMethodDescriptor methodDescriptor) {
            return TriRpcStatus.UNIMPLEMENTED.withDescription(String.format("Method %s is unimplemented",
                "/" + serviceDescriptor.getInterfaceName() + "/" + methodDescriptor.getMethodName())).asException();
        }
    }

}
